Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -5118,159 +5074,154 @@
 
 
-!AC!        do 2100 j=1,ntra
-!AC!c oct3         do 2110 k=1,nl
-!AC!         do 2110 k=1,nd ! oct3
-!AC!          do 2120 i=1,ncum
-!AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
-!AC! 2120     continue
-!AC! 2110    continue
-!AC! 2100   continue
-
+  !AC!        do 2100 j=1,ntra
+  !AC!c oct3         do 2110 k=1,nl
+  !AC!         do 2110 k=1,nd ! oct3
+  !AC!          do 2120 i=1,ncum
+  !AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
+  !AC! 2120     continue
+  !AC! 2110    continue
+  !AC! 2100   continue
 
 END SUBROUTINE cv3_uncompress
 
 
-        SUBROUTINE cv3_epmax_fn_cape(nloc,ncum,nd &
-                 , ep,hp,icb,inb,clw,nk,t,h,hnk,lv,lf,frac &
-                 , pbase, p, ph, tv, buoy, sig, w0,iflag &
-                 , epmax_diag)
-          USE lmdz_conema3
-          USE lmdz_cvflag
-
-        IMPLICIT NONE
-
-        ! On fait varier epmax en fn de la cape
-        ! Il faut donc recalculer ep, et hp qui a déjà été calculé et
-        ! qui en dépend
-        ! Toutes les autres variables fn de ep sont calculées plus bas.
-
-  include "cvthermo.h"
-  include "cv3param.h"  
-
-! inputs:
-      INTEGER, INTENT (IN)                               :: ncum, nd, nloc
-      INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb, nk
-      REAL, DIMENSION (nloc), INTENT (IN)                :: hnk,pbase
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, lv, lf, tv, h
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: clw, buoy,frac
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: sig,w0
-      INTEGER, DIMENSION (nloc), INTENT (IN)             :: iflag(nloc)
-      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
-      REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
-! inouts:
-      REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: ep,hp  
-! outputs
-      REAL, DIMENSION (nloc), INTENT (OUT)           :: epmax_diag
-
-! local
-      INTEGER i,k
-!      real hp_bak(nloc,nd)
-!      real ep_bak(nloc,nd)
-      REAL m_loc(nloc,nd)
-      REAL sig_loc(nloc,nd)
-      REAL w0_loc(nloc,nd)
-      INTEGER iflag_loc(nloc)
-      REAL cape(nloc)
-        
-        IF (coef_epmax_cape>1e-12) THEN
-        ! il faut calculer la cape: on fait un calcule simple car tant qu'on ne
-        ! connait pas ep, on ne connait pas les mélanges, ddfts etc... qui sont
-        ! necessaires au calcul de la cape dans la nouvelle physique
-        
-!        WRITE(*,*) 'cv3_routines check 4303'
-        do i=1,ncum
-        do k=1,nd
-          sig_loc(i,k)=sig(i,k)
-          w0_loc(i,k)=w0(i,k)
-          iflag_loc(i)=iflag(i)
-!          ep_bak(i,k)=ep(i,k)
-        enddo ! do k=1,nd
-        enddo !do i=1,ncum
-
-!        WRITE(*,*) 'cv3_routines check 4311'
-!        WRITE(*,*) 'nl=',nl
-        CALL cv3_closure(nloc, ncum, nd, icb, inb, & ! na->nd
-          pbase, p, ph, tv, buoy, &
-          sig_loc, w0_loc, cape, m_loc,iflag_loc)
-
-!        WRITE(*,*) 'cv3_routines check 4316'
-!        WRITE(*,*) 'ep(1,:)=',ep(1,:)
-        do i=1,ncum
-           epmax_diag(i)=epmax-coef_epmax_cape*sqrt(cape(i))
-           epmax_diag(i)=amax1(epmax_diag(i),0.0)
-!           WRITE(*,*) 'i,icb,inb,cape,epmax_diag=', &
-!                i,icb(i),inb(i),cape(i),epmax_diag(i)
-           do k=1,nl
-                ep(i,k)=ep(i,k)/epmax*epmax_diag(i)
-                ep(i,k)=amax1(ep(i,k),0.0)
-                ep(i,k)=amin1(ep(i,k),epmax_diag(i))
-           enddo
+SUBROUTINE cv3_epmax_fn_cape(nloc, ncum, nd, ep, hp, icb, inb, clw, nk, t, h, hnk, lv, lf, frac &
+        , pbase, p, ph, tv, buoy, sig, w0, iflag, epmax_diag)
+  USE lmdz_conema3
+  USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
+  IMPLICIT NONE
+
+  ! On fait varier epmax en fn de la cape
+  ! Il faut donc recalculer ep, et hp qui a déjà été calculé et
+  ! qui en dépend
+  ! Toutes les autres variables fn de ep sont calculées plus bas.
+
+  ! inputs:
+  INTEGER, INTENT (IN) :: ncum, nd, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: icb, inb, nk
+  REAL, DIMENSION (nloc), INTENT (IN) :: hnk, pbase
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: t, lv, lf, tv, h
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: clw, buoy, frac
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: sig, w0
+  INTEGER, DIMENSION (nloc), INTENT (IN) :: iflag(nloc)
+  REAL, DIMENSION (nloc, nd), INTENT (IN) :: p
+  REAL, DIMENSION (nloc, nd + 1), INTENT (IN) :: ph
+  ! inouts:
+  REAL, DIMENSION (nloc, nd), INTENT (INOUT) :: ep, hp
+  ! outputs
+  REAL, DIMENSION (nloc), INTENT (OUT) :: epmax_diag
+
+  ! local
+  INTEGER i, k
+  !      real hp_bak(nloc,nd)
+  !      real ep_bak(nloc,nd)
+  REAL m_loc(nloc, nd)
+  REAL sig_loc(nloc, nd)
+  REAL w0_loc(nloc, nd)
+  INTEGER iflag_loc(nloc)
+  REAL cape(nloc)
+
+  IF (coef_epmax_cape>1e-12) THEN
+    ! il faut calculer la cape: on fait un calcule simple car tant qu'on ne
+    ! connait pas ep, on ne connait pas les mélanges, ddfts etc... qui sont
+    ! necessaires au calcul de la cape dans la nouvelle physique
+
+    !        WRITE(*,*) 'cv3_routines check 4303'
+    do i = 1, ncum
+      do k = 1, nd
+        sig_loc(i, k) = sig(i, k)
+        w0_loc(i, k) = w0(i, k)
+        iflag_loc(i) = iflag(i)
+        !          ep_bak(i,k)=ep(i,k)
+      enddo ! do k=1,nd
+    enddo !do i=1,ncum
+
+    !        WRITE(*,*) 'cv3_routines check 4311'
+    !        WRITE(*,*) 'nl=',nl
+    CALL cv3_closure(nloc, ncum, nd, icb, inb, & ! na->nd
+            pbase, p, ph, tv, buoy, &
+            sig_loc, w0_loc, cape, m_loc, iflag_loc)
+
+    !        WRITE(*,*) 'cv3_routines check 4316'
+    !        WRITE(*,*) 'ep(1,:)=',ep(1,:)
+    do i = 1, ncum
+      epmax_diag(i) = epmax - coef_epmax_cape * sqrt(cape(i))
+      epmax_diag(i) = amax1(epmax_diag(i), 0.0)
+      !           WRITE(*,*) 'i,icb,inb,cape,epmax_diag=', &
+      !                i,icb(i),inb(i),cape(i),epmax_diag(i)
+      do k = 1, nl
+        ep(i, k) = ep(i, k) / epmax * epmax_diag(i)
+        ep(i, k) = amax1(ep(i, k), 0.0)
+        ep(i, k) = amin1(ep(i, k), epmax_diag(i))
+      enddo
+    enddo
+    !       WRITE(*,*) 'ep(1,:)=',ep(1,:)
+
+    !WRITE(*,*) 'cv3_routines check 4326'
+    ! On recalcule hp:
+    !      do k=1,nl
+    !        do i=1,ncum
+    !	  hp_bak(i,k)=hp(i,k)
+    !	enddo
+    !      enddo
+    do k = 1, nl
+      do i = 1, ncum
+        hp(i, k) = h(i, k)
+      enddo
+    enddo
+
+    IF (cvflag_ice) THEN
+
+      do k = minorig + 1, nl
+        do i = 1, ncum
+          IF((k>=icb(i)).AND.(k<=inb(i)))THEN
+            hp(i, k) = hnk(i) + (lv(i, k) + (cpd - cpv) * t(i, k) + frac(i, k) * lf(i, k)) * &
+                    ep(i, k) * clw(i, k)
+          endif
         enddo
- !       WRITE(*,*) 'ep(1,:)=',ep(1,:)
-
-      !WRITE(*,*) 'cv3_routines check 4326'
-! On recalcule hp:
-!      do k=1,nl
-!        do i=1,ncum
-!	  hp_bak(i,k)=hp(i,k)
-!	enddo
-!      enddo
-      do k=1,nl
-        do i=1,ncum
-          hp(i,k)=h(i,k)
+      enddo !do k=minorig+1,n
+    ELSE !IF (cvflag_ice) THEN
+
+      DO k = minorig + 1, nl
+        DO i = 1, ncum
+          IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
+            hp(i, k) = hnk(i) + (lv(i, k) + (cpd - cpv) * t(i, k)) * ep(i, k) * clw(i, k)
+          endif
         enddo
-      enddo
-
-  IF (cvflag_ice) THEN
-
-      do k=minorig+1,nl
-       do i=1,ncum
-        IF((k>=icb(i)).AND.(k<=inb(i)))THEN
-          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac(i,k)*lf(i,k))* &
-                              ep(i, k)*clw(i, k)
-        endif
-       enddo
       enddo !do k=minorig+1,n
-  ELSE !IF (cvflag_ice) THEN
-
-      DO k = minorig + 1, nl
-       DO i = 1, ncum
-        IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
-          hp(i,k)=hnk(i)+(lv(i,k)+(cpd-cpv)*t(i,k))*ep(i,k)*clw(i,k)
-        endif
-       enddo
-      enddo !do k=minorig+1,n
-
-  ENDIF !IF (cvflag_ice) THEN     
-      !WRITE(*,*) 'cv3_routines check 4345'
-!      do i=1,ncum  
-!       do k=1,nl
-!        if ((abs(hp_bak(i,k)-hp(i,k))/hp_bak(i,k).gt.1e-1).OR. &
-!            ((abs(hp_bak(i,k)-hp(i,k))/hp_bak(i,k).gt.1e-4).AND. &
-!            (ep(i,k)-ep_bak(i,k).lt.1e-4))) THEN
-!           WRITE(*,*) 'i,k=',i,k
-!           WRITE(*,*) 'coef_epmax_cape=',coef_epmax_cape
-!           WRITE(*,*) 'epmax_diag(i)=',epmax_diag(i)
-!           WRITE(*,*) 'ep(i,k)=',ep(i,k)
-!           WRITE(*,*) 'ep_bak(i,k)=',ep_bak(i,k)
-!           WRITE(*,*) 'hp(i,k)=',hp(i,k)
-!           WRITE(*,*) 'hp_bak(i,k)=',hp_bak(i,k)
-!           WRITE(*,*) 'h(i,k)=',h(i,k)
-!           WRITE(*,*) 'nk(i)=',nk(i)
-!           WRITE(*,*) 'h(i,nk(i))=',h(i,nk(i))
-!           WRITE(*,*) 'lv(i,k)=',lv(i,k)
-!           WRITE(*,*) 't(i,k)=',t(i,k)
-!           WRITE(*,*) 'clw(i,k)=',clw(i,k)
-!           WRITE(*,*) 'cpd,cpv=',cpd,cpv
-!           stop
-!        endif
-!       enddo !do k=1,nl
-!      enddo !do i=1,ncum  
-      endif !if (coef_epmax_cape.gt.1e-12) THEN
-      !WRITE(*,*) 'cv3_routines check 4367'
-
-
-      END SUBROUTINE  cv3_epmax_fn_cape
-
-
-
+
+    ENDIF !IF (cvflag_ice) THEN
+    !WRITE(*,*) 'cv3_routines check 4345'
+    !      do i=1,ncum
+    !       do k=1,nl
+    !        if ((abs(hp_bak(i,k)-hp(i,k))/hp_bak(i,k).gt.1e-1).OR. &
+    !            ((abs(hp_bak(i,k)-hp(i,k))/hp_bak(i,k).gt.1e-4).AND. &
+    !            (ep(i,k)-ep_bak(i,k).lt.1e-4))) THEN
+    !           WRITE(*,*) 'i,k=',i,k
+    !           WRITE(*,*) 'coef_epmax_cape=',coef_epmax_cape
+    !           WRITE(*,*) 'epmax_diag(i)=',epmax_diag(i)
+    !           WRITE(*,*) 'ep(i,k)=',ep(i,k)
+    !           WRITE(*,*) 'ep_bak(i,k)=',ep_bak(i,k)
+    !           WRITE(*,*) 'hp(i,k)=',hp(i,k)
+    !           WRITE(*,*) 'hp_bak(i,k)=',hp_bak(i,k)
+    !           WRITE(*,*) 'h(i,k)=',h(i,k)
+    !           WRITE(*,*) 'nk(i)=',nk(i)
+    !           WRITE(*,*) 'h(i,nk(i))=',h(i,nk(i))
+    !           WRITE(*,*) 'lv(i,k)=',lv(i,k)
+    !           WRITE(*,*) 't(i,k)=',t(i,k)
+    !           WRITE(*,*) 'clw(i,k)=',clw(i,k)
+    !           WRITE(*,*) 'cpd,cpv=',cpd,cpv
+    !           stop
+    !        endif
+    !       enddo !do k=1,nl
+    !      enddo !do i=1,ncum
+  endif !if (coef_epmax_cape.gt.1e-12) THEN
+  !WRITE(*,*) 'cv3_routines check 4367'
+
+END SUBROUTINE  cv3_epmax_fn_cape
+
+
+
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_compress.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_compress.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_compress.F90	(revision 5141)
@@ -29,7 +29,7 @@
   ! **************************************************************
 USE lmdz_abort_physic, ONLY: abort_physic
+USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
   ! inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_uncompress.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_uncompress.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3a_uncompress.F90	(revision 5141)
@@ -38,7 +38,7 @@
   ! **************************************************************
 
+  USE lmdz_cv3param
+
   IMPLICIT NONE
-
-  include "cv3param.h"
 
   ! inputs:
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p1_closure.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p1_closure.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p1_closure.F90	(revision 5141)
@@ -22,9 +22,9 @@
   USE lmdz_abort_physic, ONLY: abort_physic
   USE lmdz_conema3
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-  include "cvthermo.h"
-  include "cv3param.h"
   include "YOMCST2.h"
   include "YOMCST.h"
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p2_closure.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p2_closure.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p2_closure.F90	(revision 5141)
@@ -22,9 +22,9 @@
   USE lmdz_conema3
   USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-  include "cvthermo.h"
-  include "cv3param.h"
   include "YOMCST2.h"
   include "YOMCST.h"
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p_mixing.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p_mixing.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3p_mixing.F90	(revision 5141)
@@ -17,9 +17,9 @@
   USE add_phys_tend_mod, ONLY: fl_cor_ebil
   USE lmdz_cvflag
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
 
   IMPLICIT NONE
 
-  include "cvthermo.h"
-  include "cv3param.h"
   include "YOMCST2.h"
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv_driver.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv_driver.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv_driver.F90	(revision 5141)
@@ -12,4 +12,7 @@
 
   USE dimphy
+  USE lmdz_cv30, ONLY: cv30_param, cv30_prelim, cv30_feed, cv30_undilute1, cv30_trigger, cv30_compress, cv30_undilute2, &
+          cv30_closure, cv30_epmax_fn_cape, cv30_mixing, cv30_unsat, cv30_yield, cv30_tracer, cv30_uncompress
+
   IMPLICIT NONE
 
@@ -714,4 +717,6 @@
 ! ==================================================================
 SUBROUTINE cv_thermo(iflag_con)
+  USE lmdz_cvthermo
+
   IMPLICIT NONE
 
@@ -721,5 +726,4 @@
 
   include "YOMCST.h"
-  include "cvthermo.h"
 
   INTEGER iflag_con
